getExifPy =
function(files = list.files(".", pattern = "\.JPG$", full.names = TRUE), convert = TRUE)
{
  Sys.putenv("PYTHONPATH" = paste(Sys.getenv("PYTHONPATH"),
                                 system.file("python", package = "Rexif"),
                                 sep = ":"))
  library(RSPython)
  importPythonModule("EXIF")

  files <- sapply(files, file_path_as_absolute)
  ans = lapply(files, function(f) {
                         try({ x = .Python("getExif", f, .module = "EXIF")
                               if(convert)
                                 return(getExifValues(x))

                               class(x) <- "EXIF"
                               x
                             })
                      })

  names(ans) = files

  ans
}

"$.EXIF" <-
function(x, name)
{
  tmp = x[[name]]
  if(is.null(tmp))
    NA
  else
    tmp[["values"]]
}


getExifValues =
function(ex)
{
  v = sapply(names(ex), function(x) {
                          if(inherits(ex[[x]], "IFD_Tag"))
                             ex[[x]][["values"]]
                          else
                              NULL
                 })
  v
}  


getExifDate <-
function(ex, format = "%Y:%m:%d %H:%M:%S", fields = c("DateTime", "DateTimeOriginal", "DateTimeDigitized"))
{
  if(missing(fields))
     fields <- c(fields, paste(c("Image", "EXIF", "EXIF"), fields))

  idx = match(fields, names(ex))
  if(all(is.na(idx))) 
    return(NA)

  val <- do.call("$", list(ex, (fields[!is.na(idx)])[1]))

  if(is(val, "ExifEntry"))
    val <- val@value

  if(!is.na(format))
    val <- strptime(val, format)
  
  val
}
