library(Rexif)

jpgs = list.files(system.file("images", package = "Rexif"), pattern = "\.(JPG|jpg)$", recursive = TRUE, full.names = TRUE)


e = getExifPy(jpgs[1], convert = FALSE)[[1]]
e[["Image Orientation"]]

e[["Image Model"]][["values"]]
e$"Image Model"

e$"Image Make"
e$"Image DateTime"

#vals = getExifValues(e)

options(error = NULL)
exif = getExifPy(jpgs, convert = FALSE)

exif = exif[!sapply(exif, inherits, "try-error")]

 # All the observed exif entry names.
unique(unlist(lapply(exif, names)))

dimensions = getJPEGDimensions(names(exif))

d = data.frame(model = sapply(exif, function(ex) ex$"Image Model"),
               time = as.POSIXct(strptime(sapply(exif, getExifDate, format = NA), "%Y:%m:%d %H:%M:%S")),
#               time = as.POSIXct(sapply(exif, getExifDate)),  
               file = I(names(exif)),
               width = dimensions[, "width"],
               height = dimensions[, "height"])

 # Which of these cameras have no time information
table(d$model[is.na(d$time)])

# Which images are (probably) duplicated .
duplicated(d$time)

